/**
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.geronimo.samples.javaee6.restfulorder.JPASessionBeans;

import java.util.List;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Root;
import org.apache.geronimo.samples.javaee6.restfulorder.entities.Restfulorder;

@Stateless
public class RestfulorderFacade {

    @PersistenceContext(unitName = "RestfulProduct2PU")
    private EntityManager em;

    public void create(Restfulorder restfulorder) {
        em.persist(restfulorder);
    }

    public void edit(Restfulorder restfulorder) {
        em.merge(restfulorder);
    }

    public void remove(Restfulorder restfulorder) {
        em.remove(em.merge(restfulorder));
    }

    public Restfulorder find(Object id) {
        return em.find(Restfulorder.class, id);
    }

    public List<Restfulorder> findAll() {
        CriteriaQuery cq = em.getCriteriaBuilder().createQuery();
        cq.select(cq.from(Restfulorder.class));
        return em.createQuery(cq).getResultList();
    }



}
