/**
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

var useWrapRestfulorder = true;

function Restfulorder(uri_) {
    this.Restfulorder(uri_, false);
}

function Restfulorder(uri_, initialized_) {
    this.uri = uri_;
    this.id = '';
    this.customer = '';
    this.seller = '';
    this.productname = '';
    this.price = '';
    this.quantity = '';

    this.initialized = initialized_;
}

Restfulorder.prototype = {

    getUri : function() {
        return this.uri;
    },

    getId : function() {
        if(!this.initialized)
            this.init();
        return this.id;
    },

    setId : function(id_) {
        this.id = id_;
    },

    getCustomer : function() {
        if(!this.initialized)
            this.init();
        return this.customer;
    },

    setCustomer : function(customer_) {
        this.customer = customer_ ;
    },

    getSeller : function() {
        if(!this.initialized)
            this.init();
        return this.seller;
    },

    setSeller : function(seller_) {
        this.seller = seller_;
    },

    getProductname : function() {
        if(!this.initialized)
            this.init();
        return this.productname;
    },

    setProductname : function(productname_) {
        this.productname = productname_;
    },

    getPrice : function() {
        if(!this.initialized)
            this.init();
        return this.price;
    },

    setPrice : function(price_) {
        this.price = price_;
    },

    getQuantity : function() {
        if(!this.initialized)
            this.init();
        return this.quantity;
    },

    setQuantity : function(quantity_) {
        this.quantity = quantity_;
    },



    init : function() {
        var remote = new RestfulorderRemote(this.uri);
        var c = remote.getJson_();
    
        if(c != -1) {
            var myObj = eval('(' +c+')');
            var restfulorder = myObj.restfulorder;
            if(restfulorder == null || restfulorder == undefined || restfulorder['@uri'] == undefined) {
                restfulorder = myObj;
                useWrapRestfulorder = false;
            }
            this.uri = restfulorder['@uri'];
            this.id = this.findValue(this.id, restfulorder['id']);
            this.customer = this.findValue(this.customer, restfulorder['customer']);
            this.seller = this.findValue(this.seller, restfulorder['seller']);
            this.productname = this.findValue(this.productname, restfulorder['productname']);
            this.price = this.findValue(this.price, restfulorder['price']);
            this.quantity = this.findValue(this.quantity, restfulorder['quantity']);

            this.initialized = true;
        }
    },

    findValue : function(field, value) {
        if(value == undefined)
            return field;
        else
            return value;
    },

    flush : function() {
        var remote = new RestfulorderRemote(this.uri);
        if(useWrapRestfulorder)
            return remote.putJson_('{'+this.toString()+'}');
        else
            return remote.putJson_(this.toString());
    },

    delete_ : function() {
        var remote = new RestfulorderRemote(this.uri);
        return remote.deleteJson_();
    },

    toString : function() {
        if(!this.initialized)
            this.init();
        var myObj =
        '{'+
        '"@uri":"'+this.uri+'"'+
        ', "id":"'+this.id+'"'+
        ', "customer":"'+this.customer+'"'+
        ', "seller":"'+this.seller+'"'+
        ', "productname":"'+this.productname+'"'+
        ', "price":"'+this.price+'"'+
        ', "quantity":"'+this.quantity+'"'+

        '}';
        if(useWrapRestfulorder) {
            myObj = '"restfulorder":'+myObj;
        }
        return myObj;
    },

    getFields : function() {
        var fields = [];
        fields.push('id');
        fields.push('customer');
        fields.push('seller');
        fields.push('productname');
        fields.push('price');
        fields.push('quantity');

        return fields;
    }

}
function getItem(uri_){


}

function RestfulorderRemote(uri_) {
    this.uri = uri_+'?expandLevel=1';
}

RestfulorderRemote.prototype = {

    /* Default getJson_() method used by init() method. Do not remove. */
    getJson_ : function() {
        return rjsSupport.get(this.uri, 'application/json');
    },
    /* Default putJson_() method used by flush() method. Do not remove. */
    putJson_ : function(content) {
        return rjsSupport.put(this.uri, 'application/json', content);
    },
    /* Default deleteJson_() method used by delete_() method. Do not remove. */
    deleteJson_ : function() {
        return rjsSupport.delete_(this.uri);
    }
    ,
    getXml : function() {
        return rjsSupport.get(this.uri, 'application/xml');
    },

    getJson : function() {
        return rjsSupport.get(this.uri, 'application/json');
    },

    putXml : function(content) {
        return rjsSupport.put(this.uri, 'application/xml', content);
    },

    putJson : function(content) {
        return rjsSupport.put(this.uri, 'application/json', content);
    },

    delete_ : function() {
        return rjsSupport.delete_(this.uri);
    }
}
